#! /home/song3/anaconda3/bin/python

# This code is partially adapted from https://github.com/jgibbard/iqtool/blob/master/iqgen.py

import numpy as np
from matplotlib import pyplot as plt
import sys, struct
import os.path
import warnings
warnings.simplefilter('ignore')

from bitio import bit_open
from bitarray import bitarray

# Adapted from https://yangtavares.com/2017/07/13/a-viterbi-decoder-python-implementation/

def v_xor(bit0,bit1):
    if(bit0==bit1):
        return "0"
    else:
        return "1"

def viterbi_encoder(inputs):
    # convert the numbers to binary strings for easy concatenating
    inputs = [str(n) for n in inputs]
    #shift register encoder
    s_reg = ["0","0","0"]
    obs = []
    for t in range (0,len(inputs)):
        #shifting the bits to right


        #inserting input

        #encoded bits

    # The output is a list of "1" and "0"s with double length of inputs
    return obs

def readFile(filename):
    ret = []
    with bit_open(filename, "r") as f:
         while True:
            try:
                num = f.read_bits(1)
            except:
                break
            ret.append(num)

    return ret

def bits_diff_num(num_1,num_2):
    count=0;
    for i in range(0,len(num_1),1):
        if num_1[i]!=num_2[i]:
            count=count+1
    return count

def viterbi_decoder(inputs):
    # concatenating every two bits for easy handling
    inputs = [inputs[i]+inputs[i+1] for i in range(0,len(inputs),2)]
    decoded = []


    return decoded[::-1]




def addNoise(input):
    np.random.seed(1234)
    input = [str(i) for i in input]
    output = []
    for num in input:
        if len(output) < 8*8 or np.random.normal(0,0.25,1) < 0.6:
            output.append(num)
        else:
            output.append(str(abs(1-int(num))))

    return output


def writeFile(filename,inputs):
    # data = complexToSingleArray(signal)
    inputs = [str(i) for i in inputs]
    f = open(filename,"wb")
    bits = bitarray("".join(inputs))
    bits.tofile(f)
    
def diff(first, second):
    assert(len(first) == len(second))
    error = 0
    for i in range(len(first)):
        if first[i] != second[i]:
            error += 1

    return error/len(first)


if __name__ == "__main__":
    # numbers = readFile("pic1.jpg")
    numbers = ("1","0","0","1","1")
    # noisy_noncode = addNoise(numbers)
    # print("Error rate after adding noise: %7.5f"%(diff([int(n) for n in noisy_noncode],numbers)))
    # writeFile("Noisy_pic.jpg",noisy_noncode)
    encoded = viterbi_encoder(numbers)
    print(encoded)
    # noisy = addNoise(encoded)
    # decoded = viterbi_decoder(noisy)
    # print("Error rate after decoded: %7.5f"%(diff(decoded,numbers)))
    # writeFile("decoded_pic.jpg",decoded)



